Makefile.gcc-plugins 3.5 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182
  1. # SPDX-License-Identifier: GPL-2.0
  2. ifdef CONFIG_GCC_PLUGINS
  3. __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
  4. PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
  5. SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
  6. gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
  7. gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
  8. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
  9. ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
  10. DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
  11. endif
  12. ifdef CONFIG_GCC_PLUGIN_SANCOV
  13. # It is needed because of the gcc-plugin.sh and gcc version checks.
  14. gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
  15. ifeq ($(PLUGINCC),)
  16. $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
  17. endif
  18. endif
  19. gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
  20. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
  21. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL) += -fplugin-arg-structleak_plugin-byref-all
  22. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
  23. gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
  24. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
  25. gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
  26. GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
  27. export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
  28. export DISABLE_LATENT_ENTROPY_PLUGIN
  29. ifneq ($(PLUGINCC),)
  30. # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
  31. GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
  32. endif
  33. KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
  34. GCC_PLUGIN := $(gcc-plugin-y)
  35. GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
  36. endif
  37. # If plugins aren't supported, abort the build before hard-to-read compiler
  38. # errors start getting spewed by the main build.
  39. PHONY += gcc-plugins-check
  40. gcc-plugins-check: FORCE
  41. ifdef CONFIG_GCC_PLUGINS
  42. ifeq ($(PLUGINCC),)
  43. ifneq ($(GCC_PLUGINS_CFLAGS),)
  44. # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
  45. # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
  46. # issues with 64-bit targets.
  47. ifeq ($(ARCH),powerpc)
  48. ifeq ($(call cc-ifversion, -le, 0501, y), y)
  49. @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
  50. endif
  51. endif
  52. ifeq ($(call cc-ifversion, -ge, 0405, y), y)
  53. $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
  54. @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
  55. else
  56. @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
  57. endif
  58. endif
  59. endif
  60. endif
  61. @:
  62. # Actually do the build, if requested.
  63. PHONY += gcc-plugins
  64. gcc-plugins: scripts_basic gcc-plugins-check
  65. ifdef CONFIG_GCC_PLUGINS
  66. $(Q)$(MAKE) $(build)=scripts/gcc-plugins
  67. endif
  68. @: